"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const visitor_1 = __importDefault(require("./visitor"));
const acorn_1 = require("acorn");
class Jinter {
    constructor(input) {
        const program = (0, acorn_1.parse)(input, { ecmaVersion: 2020 });
        this.ast = program.body;
        this.visitor = new visitor_1.default(this.ast);
        this.scope = this.visitor.scope;
        const console_polyfill = {
            log: (args) => console.log(...args)
        };
        const string_polyfill = {
            fromCharCode: (num) => String.fromCharCode(num)
        };
        const math_polyfill = {
            pow: (args) => Math.pow(...args)
        };
        this.scope.set('console', console_polyfill);
        this.scope.set('String', string_polyfill);
        this.scope.set('Math', math_polyfill);
        this.scope.set('Date', Date);
    }
    interpret() {
        return this.visitor.run();
    }
}
exports.default = Jinter;
