"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class LogicalExpression {
    static visit(node, visitor) {
        const operator = node.operator;
        if (node.operator !== '&&' && node.operator !== '||')
            throw Error(`Unsupported logical operator: ${operator}`);
        switch (operator) {
            case '&&': {
                const left_side = visitor.visitNode(node.left);
                return left_side && visitor.visitNode(node.right);
            }
            case '||': {
                const left_side = visitor.visitNode(node.left);
                return left_side || visitor.visitNode(node.right);
            }
        }
    }
}
exports.default = LogicalExpression;
